'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildEnumValueConfigMap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = buildEnum;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

const buildEnumValueConfigMap = exports.buildEnumValueConfigMap = (enumAST, configMap = {}) => enumAST.values.reduce((map, enumValueAST) => {
  const name = enumValueAST.name.value;
  const config = configMap[name] || {};
  // set enum value to it's name by default
  const value = 'value' in config ? config.value : name;
  const description = (0, _buildASTSchema.getDescription)(enumValueAST);
  const enumValueConfig = { value };
  if ('deprecationReason' in config) enumValueConfig.deprecationReason = config.deprecationReason;
  if (description) enumValueConfig.description = description;
  return _extends({}, map, { [name]: enumValueConfig });
}, {});

function buildEnum(enumAST, { values } = {}) {
  const enumTypeConfig = {
    name: enumAST.name.value,
    values: buildEnumValueConfigMap(enumAST, values)
  };
  const description = (0, _buildASTSchema.getDescription)(enumAST);
  if (description) enumTypeConfig.description = description;
  return new _type.GraphQLEnumType(enumTypeConfig);
}