'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildInputObjectConfigFieldMap = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = buildInputObject;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

var _produceType = require('./produceType');

var _produceType2 = _interopRequireDefault(_produceType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const buildInputObjectConfigFieldMap = exports.buildInputObjectConfigFieldMap = (inputObjectAST, types) => inputObjectAST.fields.reduce((map, inputValueAST) => {
  const name = inputValueAST.name.value;
  const type = (0, _produceType2.default)(inputValueAST.type, types);
  const defaultValue = inputValueAST.defaultValue;
  const description = (0, _buildASTSchema.getDescription)(inputValueAST);
  const inputObjectFieldConfig = { type };
  if (defaultValue !== null) {
    inputObjectFieldConfig.defaultValue = type.parseLiteral(defaultValue);
  }
  if (description) inputObjectFieldConfig.description = description;
  return _extends({}, map, { [name]: inputObjectFieldConfig });
}, {});

function buildInputObject(inputObjectAST, _, types) {
  const inputObjectTypeConfig = {
    name: inputObjectAST.name.value,
    fields: () => buildInputObjectConfigFieldMap(inputObjectAST, types)
  };
  const description = (0, _buildASTSchema.getDescription)(inputObjectAST);
  if (description) inputObjectTypeConfig.description = description;
  return new _type.GraphQLInputObjectType(inputObjectTypeConfig);
}