'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildScalar;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

function buildScalar(scalarAST, config = {}) {
  const {
    serialize,
    parseValue,
    parseLiteral
  } = config instanceof _type.GraphQLScalarType ? config._scalarConfig : config;
  const scalarTypeConfig = { name: scalarAST.name.value, serialize, parseValue, parseLiteral };
  const description = (0, _buildASTSchema.getDescription)(scalarAST);
  if (description) scalarTypeConfig.description = description;
  return new _type.GraphQLScalarType(scalarTypeConfig);
}