'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = buildUnion;

var _type = require('graphql/type');

var _buildASTSchema = require('graphql/utilities/buildASTSchema');

var _produceType = require('./produceType');

var _produceType2 = _interopRequireDefault(_produceType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildUnion(unionAST, { resolveType } = {}, types) {
  const unionTypeConfig = {
    name: unionAST.name.value,
    types: unionAST.types.map(typeAST => (0, _produceType2.default)(typeAST, types)),
    resolveType
  };
  const description = (0, _buildASTSchema.getDescription)(unionAST);
  if (description) unionTypeConfig.description = description;
  return new _type.GraphQLUnionType(unionTypeConfig);
}